# Parsec Cloud (https://parsec.cloud) Copyright (c) BUSL-1.1 2016-present Scille SAS

# /!\ Autogenerated by misc/gen_protocol_typings.py, any modification will be lost !

from __future__ import annotations

from parsec._parsec import DateTime, SequesterServiceID, VlobID

class Req:
    def __init__(
        self,
        vlob_id: VlobID,
        key_index: int,
        timestamp: DateTime,
        version: int,
        blob: bytes,
        sequester_blob: dict[SequesterServiceID, bytes] | None,
    ) -> None: ...
    def dump(self) -> bytes: ...
    @property
    def blob(self) -> bytes: ...
    @property
    def key_index(self) -> int: ...
    @property
    def sequester_blob(self) -> dict[SequesterServiceID, bytes] | None: ...
    @property
    def timestamp(self) -> DateTime: ...
    @property
    def version(self) -> int: ...
    @property
    def vlob_id(self) -> VlobID: ...

class Rep:
    @staticmethod
    def load(raw: bytes) -> Rep: ...
    def dump(self) -> bytes: ...

class RepUnknownStatus(Rep):
    def __init__(self, status: str, reason: str | None) -> None: ...
    @property
    def status(self) -> str: ...
    @property
    def reason(self) -> str | None: ...

class RepOk(Rep):
    def __init__(
        self,
    ) -> None: ...

class RepAuthorNotAllowed(Rep):
    def __init__(
        self,
    ) -> None: ...

class RepBadKeyIndex(Rep):
    def __init__(self, last_realm_certificate_timestamp: DateTime) -> None: ...
    @property
    def last_realm_certificate_timestamp(self) -> DateTime: ...

class RepVlobNotFound(Rep):
    def __init__(
        self,
    ) -> None: ...

class RepBadVlobVersion(Rep):
    def __init__(
        self,
    ) -> None: ...

class RepOrganizationNotSequestered(Rep):
    def __init__(
        self,
    ) -> None: ...

class RepSequesterInconsistency(Rep):
    def __init__(self, last_common_certificate_timestamp: DateTime) -> None: ...
    @property
    def last_common_certificate_timestamp(self) -> DateTime: ...

class RepSequesterServiceUnavailable(Rep):
    def __init__(
        self,
    ) -> None: ...

class RepRejectedBySequesterService(Rep):
    def __init__(self, service_id: SequesterServiceID, reason: str) -> None: ...
    @property
    def reason(self) -> str: ...
    @property
    def service_id(self) -> SequesterServiceID: ...

class RepTimestampOutOfBallpark(Rep):
    def __init__(
        self,
        ballpark_client_early_offset: float,
        ballpark_client_late_offset: float,
        server_timestamp: DateTime,
        client_timestamp: DateTime,
    ) -> None: ...
    @property
    def ballpark_client_early_offset(self) -> float: ...
    @property
    def ballpark_client_late_offset(self) -> float: ...
    @property
    def client_timestamp(self) -> DateTime: ...
    @property
    def server_timestamp(self) -> DateTime: ...

class RepRequireGreaterTimestamp(Rep):
    def __init__(self, strictly_greater_than: DateTime) -> None: ...
    @property
    def strictly_greater_than(self) -> DateTime: ...
